--[[ Lil' Fighter PSP
     by Yongobongo, 2007
     Sprites by www.lf2.net

     Coded by Yongobongo
     http://yongobongo.recoding.net

     a Hazed Mirror and pixelNation production
--]]

filechar = io.open("Data/DATA.LF", "r")
playerchar = filechar:read()
filechar:close()

fileenemy = io.open("Data/ENEMY.LF", "r")
playerenemy = fileenemy:read()
fileenemy:close()

filearena = io.open("Data/ARENA.LF", "r")
imagearena = filearena:read()
filearena:close()

pname = io.open("Data/NAME.LF", "r")
name = pname:read()
pname:close()

-- Colours
black = Color.new(0,0,0)
white = Color.new(255,255,255)
red = Color.new(255,0,0)

-- Sounds
miss = Sound.load("Sounds/miss.wav",false)
hit = Sound.load("Sounds/hit.wav",false)
walk1 = Sound.load("Sounds/walk1.wav",false)
walk2 = Sound.load("Sounds/walk2.wav",false)
ending = Sound.load("Sounds/end.wav",false)
TimerWalk=Timer.new()
TimerHit=Timer.new()
attackinge = 1
Timere=Timer.new()
playending = 0
played = 0
playmiss = 0
playedmiss = 0

-- Images

--arena
arena = Image.load("Images/back0" .. imagearena .. ".jpg")

--character sprites
char = Image.load("Images/" ..playerchar.. "/stand.png")
char1 = Image.load("Images/" ..playerchar.. "/stand.png")
char2 = Image.load("Images/" ..playerchar.. "/left.png")
char3 = Image.load("Images/" ..playerchar.. "/right.png")
char4 = Image.load("Images/" ..playerchar.. "/punch.png")
char5 = Image.load("Images/" ..playerchar.. "/punchl.png")
char6 = Image.load("Images/" ..playerchar.. "/hit.png")
char7 = Image.load("Images/" ..playerchar.. "/hitl.png")
pic = Image.load("Images/" ..playerchar.. "/pic.png")

--enemy sprites
enemy = Image.load("Images/" .. playerenemy .. "/stand.png")
enemy1 = Image.load("Images/" .. playerenemy .. "/stand.png")
enemy2 = Image.load("Images/" .. playerenemy .. "/left.png")
enemy3 = Image.load("Images/" .. playerenemy .. "/right.png")
enemy4 = Image.load("Images/" .. playerenemy .. "/punch.png")
enemy5 = Image.load("Images/" .. playerenemy .. "/punchl.png")
enemy6 = Image.load("Images/" .. playerenemy .. "/hit.png")
enemy7 = Image.load("Images/" .. playerenemy .. "/hitl.png")
pic2 = Image.load("Images/" .. playerenemy .. "/pic.png")

-- win or lose
win = Image.load("Images/win.png")
lose = Image.load("Images/lose.png")

--lifebar
life = Image.load("Images/lifebar.png")
elife = Image.load("Images/lifebar.png")

-- make the player
status = 4
charx = 50
chary = 120
charlife = 125
direction = 1
jumping = 0
type = char3

-- blood splat; this game should be rated Mature!
blood = Image.load("Images/blood/1.png")
blood1 = Image.load("Images/blood/1.png")
blood2 = Image.load("Images/blood/2.png")
blood3 = Image.load("Images/blood/3.png")
blood4 = Image.load("Images/blood/4.png")
bloodx = charx - 5
bloody = chary + 40

-- make the enemy
enemystatus = 3
enemyx = 360
enemyy = 120
enemylife = 125
enemydirection = 1
enemyjumping = 0
etype = enemy2
runaway = 2

-- omg, items
--health potion.
math.randomseed(os.time())
Timerhp=Timer.new()
healthpot = 0
healthx = math.random(20,460)
health = Image.load("Images/Items/health.png")

-- player names
etextx = enemyx + 20
etexty = enemyy + 110
ptextx = charx + 20
ptexty = chary + 110

-- pause
pause = 0

-- attacking
attacking = 1
Timer=Timer.new()

-- allowed to hit
allowedtohit = 0
enemyallowedtohit = 0

-- collision detection script

function collision(x1, y1, w1, h1, x2, y2, w2, h2)
if (y2 >= y1 and y1 + h1 >= y2) or (y2 + h2 >= y1 and y1 + h1 >= y2 + h2) or (y1 >= y2 and y2 + h2 >= y1) or (y1 + h1 >= y2 and y2 + h2 >= y1 + h1) then
if x2 >= x1 and x1 + w1 >= x2 then
return true
elseif x2 + w2 >= x1 and x1 + w1 >= x2 + w2 then
return true
elseif x1 >= x2 and x2 + w2 >= x1 then
return true
elseif x1 + w1 >= x2 and x2 + w2 >= x1 + w1 then
return true
end
end
end

while true do
pad = Controls.read()

screen:clear(white)

-- analog stick movement method
dx = pad:analogX()
dy = pad:analogY()

if dx > 64 and charx < 464 then 
charx = charx + 2 
status = 4
end

if dx < -64 and charx > 0 then 
charx = charx - 2 
status = 3
end

if dy > 64 and chary < 256 and chary < 150 then 
chary = chary + 2 
end

if dy < -64 and chary > 0 and chary > 75 then 
chary = chary - 2 
end

-- end analog stick movement method

-- battle arena
screen:blit(0,0,arena)
screen:blit(charx,chary,char)
screen:blit(enemyx,enemyy,enemy)
screen:blit(0,0,life)
screen:blit(198,0,elife)
screen:blit(2,3,pic)
screen:blit(200,3,pic2)
screen:fillRect(57, 20, charlife, 10, red)
screen:fillRect(255, 20, enemylife, 10, red)
char:clear()
enemy:clear()
char:blit(0,0,type)
enemy:blit(0,0,etype)

--player status

if status == 1 then
type = char1
end

if status == 2 then
type = char4
end

if status == 3 then
type = char2
end

if status == 4 then
type = char3
end

if status == 5 then
type = char5
end

if status == 6 then
type = char6
end

if status == 7 then
type = char7
end

--enemy status

if estatus == 1 then
etype = enemy1
end

if estatus == 2 then
etype = enemy4
end

if estatus == 3 then
etype = enemy2
end

if estatus == 4 then
etype = enemy3
end

if estatus == 5 then
etype = enemy5
end

if estatus == 6 then
etype = enemy6
end

if estatus == 7 then
etype = enemy7
end

if not pad:left() and not pad:right() and not pad:cross() and not pad:circle() then
status = 1
end

if not pad:right() and not pad:left() then
status = 1
end

if pad:left() then
charx = charx - 2
status = 3
screen.waitVblankStart(0.5)
end

if pad:right() then
charx = charx + 2
status = 4
screen.waitVblankStart(0.5)
end

if dx < -64 and pad:cross() then
attacking = 1
allowedtohit = 0
status = 5
end

if dx > 64 and pad:cross() then
attacking = 2
allowedtohit = 0
status = 4
end

if pad:cross() and status == 3 then
attacking = 1
allowedtohit = 0
end

if pad:cross() and status == 4 then
attacking = 2
allowedtohit = 0
end

if pad:cross() and dx < -64 and charx > 0 then 
attacking = 1
end

if pad:cross() and dx < -64 and charx > 0 then 
attacking = 1
end

if pad:cross() and status == 1 then
attacking = 2
allowedtohit = 0
end

if attacking == 1 then
Timer:start()
AtkTimer=Timer:time()
status = 5
direction = 1
end

if attacking == 2 then
Timer:start()
AtkTimer=Timer:time()
status = 2
direction = 2
end

if AtkTimer > 900 and direction == 1 then
Timer:stop()
Timer:reset(0)
attacking = 0
status = 1
end

if AtkTimer > 900 and direction == 2 then
Timer:stop()
Timer:reset(0)
attacking = 0
status = 1
end

if pad:up() and chary > 75 then
chary = chary - 2
status = 1
screen.waitVblankStart(0.5)
end

if pad:down() and chary < 150 then
chary = chary + 2
status = 1
screen.waitVblankStart(0.5)
end

if charx < 0 then
charx = 0
end

if charx > 480 then
charx = 480
end

if pause == 1 then
dofile("paused.lua")
screen.waitVblankStart()
end

if pad:start() and pause == 1 then
pause = 0
screen.waitVblankStart(5)
elseif pad:start() then
pause = 1
end

if pad:circle() and chary > 50 then
jumping = 1
end

if jumping == 1 and chary < 300 then
chary = chary - 2
screen.waitVblankStart(0.5)
jumping = 2
state = 1
end

if jumping == 2 then
jumping = 1
end

if jumping == 1 and chary < 0 then
jumping = 3
end

if jumping == 3 then
chary = chary + 3
screen.waitVblankStart(0.5)
jumping = 4
state = 1
end

if jumping == 4 then
jumping = 3
end

if jumping == 3 and chary > 100 then
jumping = 0
end

if collision(charx, chary, 70, 100, enemyx, enemyy, 70, 100) and attacking == 1 and allowedtohit == 0 then
enemylife = enemylife - 2.5
allowedtohit = 1
hit:play()
attacking = 0
attackinge = 0
enemyx = enemyx - 7
runAway = 3
enemy:blit(10,50,blood3)
screen.waitVblankStart(3.5)
estatus = 6
elseif attacking == 1 then
playmiss = 1
playedmiss = 0
end

if collision(charx, chary, 70, 100, enemyx, enemyy, 70, 100) and attacking == 2 and allowedtohit == 0 then
enemylife = enemylife - 2.5
allowedtohit = 1
hit:play()
attacking = 0
attackinge = 0
enemyx = enemyx + 7
enemy:blit(10,50,blood3)
screen.waitVblankStart(3.5)
estatus = 7
elseif attacking == 2 then
playmiss = 1
playedmiss = 0
end

Timerhp:start()
hptime=Timerhp:time()

if hptime > 10000 then
healthpot = math.random(1,4)
screen:blit(healthx,200,health)
Timerhp:stop()
healthpot = 5
elseif hptime > 10000 then
healthpot = 6
screen:blit(-10,-10,health)
health:clear()
end

if enemylife < 1 then
screen:blit(0,0,win)
enemyx = 600
playending = 1
end

if charlife < 1 then
screen:blit(0,0,lose)
enemyx = 600
playending = 1
end

if playending == 1 and played == 0 then
ending:play()
screen.waitVblankStart(50)
playending = 0
played = 1
end

if playmiss == 1 and playedmiss == 0 then
miss:play()
playmiss = 0
playedmiss = 1
end

if enemyx > 460 then
enemyx = 460
end

if enemyx < 0 then
enemyx = 0
end

if pad:start() and enemylife < 1 then
dofile("index.lua")
end

if pad:start() and charlife < 1 then
dofile("index.lua")
end

--// AI //

function moveEnemy()
enemyx = enemyx - 1
estatus = 3
end

function moveEnemyleft()
enemyx = enemyx + 1
estatus = 4
end

if not collision(charx, chary, 65, 100, enemyx, enemyy, 70, 100) then
moveEnemy()
end

--enemyatk = math.random(1,2)

if collision(charx, chary, 78, 80, enemyx, enemyy, 70, 100) and enemylife > 0 then
attackinge = 1
end

if attackinge == 1 and enemyy == chary then
Timere:start()
AtkTimere=Timere:time()
enemyallowedtohit = 0
estatus = 5
end

if AtkTimere > 900 then
Timere:stop()
Timere:reset(0)
attacking = 0
enemyallowedtohit = 1
status = 1
end

if collision(charx, chary, 65, 80, enemyx, enemyy, 70, 100) and attackinge == 1 and enemyallowedtohit == 0 then
runAway = 1
charlife = charlife - 2.5
hit:play()
attackinge = 0
enemyallowedtohit = 1
charx = charx - 5
char:blit(10,50,blood3)
screen.waitVblankStart(3.5)
status = 6
elseif attackinge == 1 then
miss:play()
status = 1
attackinge = 0
end

if runAway == 1 and enemyx < 400 and not collision(charx, chary, 70, 100, enemyx, enemyy, 70, 100) then
estatus = 4
enemyx = enemyx + 3
elseif runAway == 1 then
runAway = 2
end

if runAway == 3 and enemyx < 400 and not collision(charx, chary, 70, 100, enemyx, enemyy, 70, 100) then
estatus = 4
enemyx = enemyx + 2
elseif runAway == 1 then
runAway = 2
end

if attacking == 1 and collision(charx, chary, 90, 100, enemyx, enemyy, 70, 100) then
runAway = 3
end

if attacking == 2 and collision(charx, chary, 90, 100, enemyx, enemyy, 70, 100) then
runAway = 3
end

if enemyx < 10 then
runAway = 3
end

if enemyx > 400 then
enemyx = enemyx - 2
moveEnemy()
runAway = 0
end

if enemyy < chary and collision(charx, chary, 120, 80, enemyx, enemyy, 70, 100) then
enemyy = enemyy + 1
end

if enemyy > chary and collision(charx, chary, 120, 80, enemyx, enemyy, 70, 100) and jumping == 0 then
enemyy = enemyy - 1
end

--// AI //

if collision(charx, chary, 70, 100, healthx, 200, 13, 23) and healthpot == 5 then
charlife = 125
healthpot = 6
healthx = -20
health:clear()
end

if collision(enemyx, enemyy, 70, 100, healthx, 200, 13, 23) and healthpot == 5 then
enemylife = 125
healthpot = 6
healthx = -20
health:clear()
end

if charx > 460 then
charx = 460
end

screen:print(charx + 10, chary + 101,name,black)
screen:print(charx + 11, chary + 100,name,white)

screen:print(enemyx + 9, enemyy + 101,"COM",black)
screen:print(enemyx + 10, enemyy + 100,"COM",white)

screen.flip()
screen.waitVblankStart()
end

-- end script